defmodule GiveAway do
  @moduledoc """
  GiveAway is a library for generating social media sharing URLs.
  """

  @doc """
  Returns a list of sharing urls by delegating to `GiveAway.url/2`.
  """
  def urls(modules, params) do
    Enum.map(modules, &(url &1, params))
  end

  @doc """
  Returns a single sharing url.
  """
  def url({label, module}, params) do
    {label, apply(module, :url, [params])}
  end
end
